loanApp/loanApp/urls.py
from django.contrib import admin
from django.contrib.auth import views as auth_views
from django.urls import path, include
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from userApp import views as uaw

urlpatterns = [
    # Django admin
    path('admin/', admin.site.urls),

    # loging and password
    # path('', include('django.contrib.auth.urls')),
    path('login/', auth_views.LoginView.as_view(), name='login'),
    path('logout/', auth_views.LogoutView.as_view(), name='logout'),
    path('password_reset/', auth_views.PasswordResetView.as_view(template_name='password/password_reset_form.html'),
         name='password_reset'),
    path('password_reset/done/',
         auth_views.PasswordResetDoneView.as_view(template_name='password/password_reset_done.html'),
         name='password_reset_done'),
    path('reset/<uidb64>/<token>/',
         auth_views.PasswordResetConfirmView.as_view(template_name='password/password_reset_confirm.html'),
         name='password_reset_confirm'),
    path('reset/done/',
         auth_views.PasswordResetCompleteView.as_view(template_name='password/password_reset_complete.html'),
         name='password_reset_complete'),

    path('', include('userApp.urls')),
    path('', include('register.urls')),
    path('check', uaw.check_user, name='check_user'),

    # Loan App admin
    path('', include('adminApp.urls')),
    ]
urlpatterns += staticfiles_urlpatterns()

loanApp/userApp/urls.py
from django.urls import path
from . import views

urlpatterns = [
    path('', views.main, name='home'),
    path('dashboard', views.dashboard, name='dashboard'),
    path('loan', views.loan_trans, name='loan_trans'),
    path('contrib', views.contrib_trans, name='contrib_trans'),
    path('application', views.loan_application, name='loan_application'),
    path('dw_report', views.generate_pdf_for_review, name='dw_report'),
    path('about_us', views.about_us, name='about_us'),
    path('contact_us', views.contact_us, name='contact_us'),
    path('download_contrib', views.download_contrib, name='download_contrib'),
    path('download_loan', views.download_loan, name='download_loan'),
]

loanApp/userApp/models.py
from django.db import models
from django.contrib.auth.models import User
from loanApp.settings import DEFAULT_INTEREST_RATE


class Contribution(models.Model):
    staff_id = models.ForeignKey(User, null=True, on_delete=models.SET_NULL)
    date_created = models.DateField(auto_now_add=True, null=True)
    description = models.CharField(max_length=200)
    amount = models.FloatField(null=True)

    def __str__(self):
        return self.amount


class Loan(models.Model):
    STATUS = (
        ('NEW', 'NEW'),
        ('Top Up', 'Top Up'),
        ('Emergency', 'Emergency')
    )
    staff_id = models.ForeignKey(User, null=True, on_delete=models.SET_NULL)
    status = models.CharField(max_length=100, null=True, choices=STATUS)
    date_created = models.DateField(auto_now_add=True, null=True)
    description = models.CharField(max_length=200, null=True)
    initial_amount = models.FloatField(null=True)
    interest = models.FloatField(default=DEFAULT_INTEREST_RATE, null=True)
    amount = models.FloatField(null=True)
    processing_fee = models.FloatField(null=True)
    disbursed = models.FloatField(null=True)
    approved = models.BooleanField(null=True)

    def save(self, *args, **kwargs):
        if not self.approved:
            self.processing_fee = None
        super().save(*args, **kwargs)

    def __str__(self):
        return self.amount

loanApp/userApp/forms.py
from django import forms
from .models import Loan
from loanApp.settings import DEFAULT_INTEREST_RATE


class LoanApplication(forms.ModelForm):
    LOAN_CHOICES = (
        ('NEW', 'NEW'),
        ('Top Up', 'Top Up'),
        ('Emergency', 'Emergency')
    )
    status = forms.CharField(label="Loan Type", widget=forms.Select(choices=LOAN_CHOICES))
    period = forms.IntegerField(required=True, label="Period in Months")
    initial_amount = forms.FloatField(required=True)
    monthly_payment = forms.CharField(label="Monthly Payment Amount", required=True,
                              widget=forms.NumberInput(attrs={'readonly': True}))

    disbursed_amount = forms.FloatField(label="Disbursed Amount", required=True,
                                   widget=forms.NumberInput(attrs={'readonly': True}))

    amount = forms.FloatField(label="Total Amount", required=True,
                              widget=forms.NumberInput(attrs={'readonly': True}))

    interest = forms.FloatField(required=True, label="Interest Rate",
                                widget=forms.NumberInput(attrs={
                                    'value': DEFAULT_INTEREST_RATE,
                                    'readonly': True}))

    class Meta:
        model = Loan
        fields = ("status", 'initial_amount', "period", 'interest', "amount")

loanApp/userApp/views.py
import threading
from django.http import HttpResponse
from django.shortcuts import render, redirect, reverse
from django.contrib.auth.decorators import login_required
from django.contrib import messages
from django.utils.safestring import mark_safe
from utils import reporting, twilio, constants
from utils import paginate, export
from .forms import LoanApplication
from .models import Loan
from register.models import User
from loanApp import settings
from django.db.models import Sum
from adminApp.models import Reviewer

loan_form = LoanApplication()


def main(request):
    # print("USER OBJECT TYPE: ", type(request.user))
    return render(request, 'home.html', {"form": loan_form, 'disbursed': settings.DEFAULT_DISBURSED})


def check_user(request):
    print("check user: ", request.user.is_superuser)
    if request.user.is_superuser:
        return redirect("/admin_dashboard")
    return redirect("/dashboard")


@login_required
def dashboard(request):
    total_loans = 0.0
    total_contribs = 0.0
    if not request.user.is_superuser:
        total_loans = request.user.loan_set.filter(approved=True).aggregate(Sum('amount'))
        total_contribs = request.user.contribution_set.all().aggregate(Sum('amount'))
        if not request.user.userprofile.verified:
            request.session['phone_no'] = str(request.user.userprofile.phone_no)
            request.session['staff_id'] = str(request.user.username)
            print("user is not valid staff_id ", request.user.username)
            redirect('/logout')
            return render(request, 'not_verified.html', {})

    return render(request, 'dashboard.html', {"form": loan_form,
                                              'disbursed': settings.DEFAULT_DISBURSED,
                                              'total_loans': total_loans,
                                              'total_contribs': total_contribs})


@login_required
def contrib_trans(request):
    page = request.GET.get('page', 1)
    contribs = paginate.get_contrib_list(request.user, page, settings.TRANS_PER_PAGE)
    return render(request, 'contrib_trans.html', {"form": loan_form,
                                                  'contribs': contribs,
                                                  'disbursed': settings.DEFAULT_DISBURSED})


@login_required
def loan_trans(request):
    page = request.GET.get('page', 1)
    loans = paginate.get_loan_list(request.user, page, settings.TRANS_PER_PAGE)
    return render(request, 'loan_trans.html', {"form": loan_form,
                                               'loans': loans,
                                               'disbursed': settings.DEFAULT_DISBURSED})


@login_required
def loan_application(request):
    if request.method == "POST":
        # print("loan application is called...")
        loan_app = LoanApplication(request.POST)
        # print("Loan App", loan_app, "\n")
        # print("Loan POST", request.POST, "\n")
        if loan_app.is_valid():
            # print("USER OBJECT TYPE: ", type(request.user))

            # save the loan in the database
            # loan_app.save(commit=False)
            print("disbursed : ", loan_app.cleaned_data['disbursed_amount'])
            print("disbursed2 : ", request.POST.get("disbursed_amount"))

            loan_obj = request.user.loan_set.filter(approved=None)
            if loan_obj.count() > 0:
                error_msg = constants.LOAN_APPLICATION_ERROR % request.user.first_name
                print("More than 1 loan", error_msg)
                messages.error(request, error_msg)
                return redirect(reverse('dashboard'))

            loan_model = Loan.objects.create(
                staff_id=request.user,
                amount=-loan_app.cleaned_data['amount'],
                initial_amount=loan_app.cleaned_data.get('initial_amount'),
                approved=None,
                disbursed=loan_app.cleaned_data['disbursed_amount']
            )
            print(loan_model.staff_id)

            # create the loan pdf and send the email
            loan = dict()
            loan['staff_id'] = request.user.username
            loan['type'] = str(loan_app.cleaned_data.get('status'))
            loan['period'] = str(loan_app.cleaned_data.get('period'))
            loan['first_name'] = request.user.first_name
            loan['last_name'] = request.user.last_name
            loan['email'] = request.user.email
            loan['phone_no'] = request.user.userprofile.phone_no
            loan['contract_end'] = request.user.userprofile.contract_end
            loan['amount'] = str(loan_app.cleaned_data.get('initial_amount'))
            loan['rate'] = request.POST.get("interest")
            loan['monthly_payment'] = request.POST.get("monthly_payment")
            loan['disbursed_amount'] = request.POST.get("disbursed_amount")
            loan["total_amount"] = request.POST.get("amount")

            # generate pdf report and email to the reviewers
            context_dict = {"loan": loan,
                            "host": request.scheme + "://" + request.META['HTTP_HOST']}

            href = generate_href(context_dict)
            success_message = constants.LOAN_APPLICATION_SUCCESS % href
            # print("loan application ", success_message)
            messages.success(request, mark_safe(success_message))
            # TODO disable multithreading if the number of user is large
            threading.Thread(target=communicate_with_reviewer, args=(context_dict,)).start()
            #     communicate_with_reviewer(context_dict)

            # html = reporting.render_template('loan_application_report.html', context_dict)
            # pdf = reporting.render_to_pdf(html)
            # if pdf is not None:
            #     # if not email_succ:
            #     #     print(constants.EMAIL_TO_ADMIN_FAILED)
            #     return HttpResponse(pdf, content_type='application/pdf')
            # else:
            #     messages.error(request, constants.LOAN_APPLICATION_ERROR)
    return redirect('/dashboard')


@login_required
def download_contrib(request):
    if 'download' in request.GET:

        loans = request.user.contribution_set.all()
        file_request = export.export_to_xlsx_for_user(
            loans, constants.EXPORT_CONTIRB_FOR_USER % request.user.first_name
        )
        return file_request
    else:
        return render(request, 'download.html', {"form": loan_form, 'disbursed': settings.DEFAULT_DISBURSED})


@login_required
def download_loan(request):
    if 'download' in request.GET:

        loans = request.user.loan_set.all()
        file_request = export.export_to_xlsx_for_user(
            loans, constants.EXPORT_LOAN_FOR_USER % request.user.first_name
        )
        return file_request
    else:
        return render(request, 'download.html', {"form": loan_form, 'disbursed': settings.DEFAULT_DISBURSED})


def generate_pdf_for_review(request):
    loan = dict()
    loan['staff_id'] = request.GET.get('u')
    loan['type'] = request.GET.get('t')
    loan['period'] = request.GET.get('pe')
    loan['first_name'] = request.GET.get('f')
    loan['last_name'] = request.GET.get('l')
    loan['email'] = request.GET.get('e')
    loan['phone_no'] = request.GET.get('p')
    loan['contract_end'] = request.GET.get('c')
    loan['amount'] = request.GET.get('a')
    loan['rate'] = request.GET.get('r')
    loan['monthly_payment'] = request.GET.get('m')
    loan['disbursed_amount'] = request.GET.get('d')
    loan["total_amount"] = request.GET.get('ta')
    context_dict = {"loan": loan}
    html = reporting.render_template('loan_application_report.html', context_dict)
    pdf = reporting.render_to_pdf(html)
    if pdf is not None:
        return HttpResponse(pdf, content_type='application/pdf')
    else:
        return HttpResponse(constants.REVIEWER_LOAN_APPLICATION_ERROR)


def about_us(request):
    return render(request, 'about_us.html', {"form": loan_form, 'disbursed': settings.DEFAULT_DISBURSED})


def contact_us(request):
    return render(request, 'contact_us.html', {"form": loan_form, 'disbursed': settings.DEFAULT_DISBURSED})


def communicate_with_reviewer(context_dict):
    """
    It sends email to all the reviewers, regarding the new loans.
    """
    email_html = reporting.render_template('email_report.html',
                                           context_dict, True)
    print(">> EMAIL Report: ", email_html)

    reviewers_list = Reviewer.objects.all()
    for r in reviewers_list:
        email_succ = twilio.send_email(r.email, email_html)
        print("sending the email to the reviewer %s was successful: %s" % (r.name, email_succ))
        # TODO to handle the twilio errors if required


def generate_href(context_dict):
    param = "?u={0}&t={1}&pe={2}&f={3}&l={4}&e={5}&p={6}&c={7}&a={8}&r={9}&m={10}&d={11}&ta={12}".format(
        context_dict['loan']['staff_id'],
        context_dict['loan']['type'],
        context_dict['loan']['period'],
        context_dict['loan']['first_name'],
        context_dict['loan']['last_name'],
        context_dict['loan']['email'],
        context_dict['loan']['phone_no'],
        context_dict['loan']['contract_end'],
        context_dict['loan']['amount'],
        context_dict['loan']['rate'],
        context_dict['loan']['monthly_payment'],
        context_dict['loan']['disbursed_amount'],
        context_dict['loan']["total_amount"],
    )
    # context_dict['param'] = param
    href = "{0}{1}{2}".format(context_dict['host'], reverse('dw_report'), param)
    return href

loanApp/userApp/templates/admin_sidebar.html
{% load static %}

<ul class="custom-scrollbar">
    <!-- Logo -->
    <li class="mt-5 pb-4">
        <div class="row justify-content-center">
            <div class="col-md-6 col-6 pl-1">
                <a href="#"><img src='{% static "js_css/img/logo.jpeg" %}'
                                 class="rounded z-depth-2 img-thumbnail" alt="Logo"></a>
            </div>
        </div>
    </li>
    <li class="mt-4">
        <div class="row justify-content-center">
            <div class="h4-responsive">PsiMwStaffSav</div>
        </div>
    </li>
    <!--/. Logo -->

    <!-- Side navigation links -->
    <li>
        <ul class="collapsible collapsible-accordion">
            <li>
                <a href="{% url 'user_list' %}"
                   class="collapsible-header waves-effect">
                    <i class="fa fa-users fa-1x mr-2"></i>Staffs
                </a>
            </li>
            <li>
                <a data-toggle="modal" data-target="#ImportModal"
                   class="collapsible-header waves-effect">
                    <i class="fas fa-upload fa-1x mr-2"></i>Import Loan/Contribution
                </a>
            </li>
            <li>
                <a href="{% url 'pending' %}"
                   class="collapsible-header waves-effect">
                    <i class="fas fa-stamp mr-2"></i>Pending Loans
                </a>
            </li>
            <li>
                <a href="{% url 'reviewers' %}"
                   class="collapsible-header waves-effect">
                    <i class="fas fa-search-dollar mr-2"></i>Reviewers
                </a>
            </li>
            <li><a class="collapsible-header waves-effect" href="{% url 'about_us' %}"><i class="fas fa-eye mr-2"></i>About
                us</a>
            </li>
            <li><a class="collapsible-header waves-effect" href="{% url 'contact_us' %}"><i
                    class="far fa-envelope mr-2"></i>Contact us</a>
            </li>
            {% if user.is_authenticated %}
            <li><a class="collapsible-header waves-effect" href="{% url 'logout' %}">
                <i class="fas fa-sign-out-alt mr-2"></i>Logout</a>
            </li>
            {% endif %}
        </ul>
    </li>
    <!--/. Side navigation links -->
</ul>

loanApp/userApp/templates/base.html
<!DOCTYPE html>
<html lang="en">
{% load static %}
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <meta http-equiv="x-ua-compatible" content="ie=edge">
    <title>Loan Application</title>
    <!-- Font Awesome -->
    <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.11.2/css/all.css">
    <!-- Google Fonts Roboto -->
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Roboto:300,400,500,700&display=swap">
    <!-- Bootstrap core CSS -->
    <link rel="stylesheet" href='{% static "js_css/css/bootstrap.min.css" %}'>
    <!-- Material Design Bootstrap -->
    <link rel="stylesheet" href='{% static "js_css/css/mdb.min.css" %}'>
    <!-- Your custom styles (optional) -->
    <link rel="stylesheet" href='{% static "js_css/css/style.css" %}'>
    <!-- custom css styles -->
    <link rel="stylesheet" href='{% static "js_css/css/custom_style.css" %}'>
    <!-- custom navbar css styles -->
    <link rel="stylesheet" href='{% static "js_css/css/custom_sidebar.css" %}'>
    <!-- custom responsive table css styles -->
    <link rel="stylesheet" href='{% static "js_css/css/responsive_table.css" %}'>

</head>
<body class="fixed-sn">

{% include 'sidebar.html' %}


<!-- Start your project here-->
{% block content %}
{% endblock %}
<!-- End your project here-->

<!-- Central Modal Medium Danger -->
<div class="modal fade" id="loanNotEligibleModal" tabindex="-1" role="dialog" aria-labelledby="myModalLabel"
     aria-hidden="true">
    <div class="modal-dialog modal-notify modal-danger" role="document">
        <!--Content-->
        <div class="modal-content">
            <!--Header-->
            <div class="modal-header">
                <p class="heading lead">Not Eligible</p>

                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true" class="white-text">&times;</span>
                </button>
            </div>

            <!--Body-->
            <div class="modal-body">
                <div class="text-center">
                    <i class="fas fa-times fa-4x mb-3 animated rotateIn"></i>
                    <p>Based on your requested loan amount and period, you are not eligible for a loan.</p>
                </div>
            </div>

            <!--Footer-->
            <div class="modal-footer justify-content-center">
                <a type="button" class="btn btn-outline-danger waves-effect" data-dismiss="modal">Ok</a>
            </div>
        </div>
        <!--/.Content-->
    </div>
</div>
<!-- Central Modal Medium Danger-->
<!-- jQuery -->
<script type="text/javascript" src='{% static "js_css/js/jquery.min.js" %}'></script>
<!-- Bootstrap tooltips -->
<script type="text/javascript" src='{% static "js_css/js/popper.min.js" %}'></script>
<!-- Bootstrap core JavaScript -->
<script type="text/javascript" src='{% static "js_css/js/bootstrap.min.js" %}'></script>
<!-- MDB core JavaScript -->
<script type="text/javascript" src='{% static "js_css/js/mdb.min.js" %}'></script>
<!-- Your loan calculation scripts -->
<script type="text/javascript" src='{% static "js_css/js/pmt.js" %}'></script>
<script type="text/javascript" src='{% static "js_css/js/mortgage.js" %}'></script>
<script type="text/javascript"></script>

{% if user.is_authenticated and not user.is_superuser %}
<script>

    $('input').keyup(function(){ // run anytime the value changes
        var rate = Number($('#id_interest').prop('defaultValue')); // get value of field
        var amount = Number($('#id_initial_amount').val()); // convert it to a float
        var period = Number($('#id_period').val());
        var interest = (rate * amount) / 100;

        var monthly_payment = mortgage(amount, period, rate/100);
        console.log('monthly payment: ', monthly_payment.toLocaleString('en-US', {maximumFractionDigits:2}));
        $('#id_monthly_payment').val(monthly_payment.toFixed(3));

        var disbursed_amount = amount * {{disbursed}}
        $('#id_disbursed_amount').val(disbursed_amount.toFixed(3));
        console.log("disbursed: ", disbursed_amount.toLocaleString('en-US', {maximumFractionDigits:2}))
        // calculate pmt
        var pmt_result = PMT(rate/100 , period, amount, 0, 0); // rate, period * 12, pv, fv, type
        console.log("pmt_result", pmt_result);

        total_amount = (monthly_payment * period);
        console.log("total_amount: ", total_amount.toLocaleString('en-US', {maximumFractionDigits:2}), "rate: ", rate, "period: ", period);
        $('#id_amount').val(total_amount.toFixed(3));
    });

</script>

<script>
// check for eligibility for a loan
    function eligibleForLoan() {
        var rate = Number($('#id_interest').prop('defaultValue')); // get value of field
        var amount = Number($('#id_amount').val()); // convert it to a float
        var period = Number($('#id_period').val());
        var contract_end = new Date('{{ user.userprofile.contract_end }}');
        var due_date = new Date();
        var net_sal = {{ user.userprofile.net_sal }};
        var pmt_result = PMT(rate/100 , period, amount , 0 , 0);

        console.log("today date: ", due_date, "contract_end", contract_end);
        due_date.setMonth(due_date.getMonth() + period);
        console.log("due_date < contract_end |", due_date.getTime() < contract_end.getTime(), "|", due_date);

        console.log("check: pmt ", (Math.abs(pmt_result) < (net_sal/2)));
        if((Math.abs(pmt_result) < (net_sal/2)) && (due_date.getTime() < contract_end.getTime())){
            console.log("check: Eligible for loan");
            return true;
        } else{
            return false;
        }
};

$(function() {
  $("#loanForm").on("submit",function(e) {
    if (!eligibleForLoan()) {
      console.log("Not eligible for loan", 'net_sal', {{ user.userprofile.net_sal }})
      // alert('Based on your amount and period, you are not eligible for a loan');
      $('#LoanApplicationModal').modal('hide') // to hide the loan application form
      $('#loanNotEligibleModal').modal('show'); // to show the error modal
      return false; // cancel submit
    }
    console.log("Eligible for loan")
    $('#LoanApplicationModal').modal('hide')
    return true; // allow submit
  });
});

</script>

{% endif %}
<script>
$(document).ready(function() {

  // SideNav Button Initialization
  $(".button-collapse").sideNav('hide');
  // SideNav Scrollbar Initialization
  //var sideNavScrollbar = document.querySelector('.custom-scrollbar');
  //var ps = new PerfectScrollbar(sideNavScrollbar);
})




</script>
<script>
        function showProgressBar() {
            document.getElementById("submitProgressbar").style.display = "block";
        }


</script>
</body>
</html>

loanApp/userApp/templates/contact_us.html
{% extends 'base.html' %}


{% block content %}
<div class="container my-5">
    <h1> Contact Us</h1>
     <p class="mt-5">
        Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut sodales orci nec dui porta aliquet. Donec in
        ultrices purus, eu varius neque. Maecenas euismod, velit non dapibus cursus, arcu neque vehicula urna, a aliquam
        nisi nibh in nisl. In et turpis blandit, lobortis leo a, pulvinar dui. Aliquam dapibus nunc nisi, at rhoncus
        lorem aliquet eget. Etiam vel tellus commodo, pharetra enim vitae, blandit purus. Morbi in lectus vel massa
        congue molestie sed sit amet nisi. Vivamus congue tortor dui, eu ultrices magna dignissim et. Aenean suscipit
        ipsum nunc, nec consequat erat sodales at. Vivamus purus nulla, interdum tristique consequat non, condimentum ac
        dui. Duis magna urna, tempor in eros ut, placerat sagittis mauris. Cras nec lacus a lectus condimentum accumsan
        sed feugiat velit. Donec eu mi in nisi ultrices pretium ut ut augue.
    </p>
    <p>
        Ut vitae lectus fermentum, vestibulum ligula eget, pretium ex. Integer pellentesque ipsum nulla, nec consectetur
        turpis interdum vitae. Aliquam varius, lacus in porta accumsan, ligula quam congue turpis, et fringilla ligula
        lorem a dolor. Pellentesque placerat purus id imperdiet fringilla. Integer ligula justo, fringilla id molestie
        vitae, posuere sed magna. Integer sit amet varius nulla. Phasellus vitae velit sodales, ultricies dui sed,
        pellentesque neque. Suspendisse dapibus convallis ipsum porttitor auctor. Cras sed magna ornare, porta neque
        quis, lobortis tellus. Duis libero leo, tincidunt at arcu id, elementum imperdiet diam. Donec at quam in diam
        convallis tempor.
    </p>
    <p>
        Orci varius natoque penatibus et magnis dis parturient montes, nascetur ridiculus mus. Maecenas vitae cursus
        metus, non porttitor metus. Donec at vulputate eros. Ut ut elit mauris. Duis nec consectetur lectus. Nulla risus
        urna, ornare quis elit quis, tristique porta urna. Pellentesque libero nulla, iaculis et laoreet ac, tempus ac
        ante. Interdum et malesuada fames ac ante ipsum primis in faucibus. Duis euismod, nisi sit amet tempor
        hendrerit, ligula quam convallis eros, non interdum tortor dui a dolor. Ut ultricies sapien erat, sit amet
        tincidunt augue egestas sed.
    </p>
    <p>
        Morbi mi ipsum, viverra eu finibus non, vestibulum ac mauris. Nam tincidunt laoreet massa ut pulvinar.
        Vestibulum ac ante nec arcu fermentum aliquam. Sed varius dolor a ex condimentum, quis pellentesque est aliquet.
        Pellentesque suscipit imperdiet elit, vel sagittis justo efficitur sed. Sed non turpis faucibus, vestibulum
        mauris in, bibendum odio. Curabitur eget magna mi. Maecenas non accumsan massa. Vivamus hendrerit sem libero,
        vel mollis tellus sollicitudin non. Etiam iaculis ullamcorper luctus. Sed vitae tincidunt tellus. Donec at dolor
        quis urna imperdiet rutrum non sed elit. Class aptent taciti sociosqu ad litora torquent per conubia nostra, per
        inceptos himenaeos.
    </p>
    <p>

        Pellentesque finibus laoreet ligula, sit amet ultricies urna sollicitudin cursus. Sed fermentum sapien vulputate
        urna sagittis, ac lobortis massa ultricies. Quisque ut rhoncus elit, eget congue magna. Duis tempor leo et
        tellus varius, et rhoncus quam viverra. Vestibulum iaculis lectus pulvinar, scelerisque nunc non, facilisis
        erat. Proin pretium tellus vel tortor suscipit, ac porttitor lacus tristique. Pellentesque non erat at nulla
        cursus gravida. Vestibulum porttitor ultricies neque, at tempus odio posuere at. Vestibulum nibh nulla, eleifend
        tristique lacus a, viverra cursus quam. Suspendisse accumsan justo nec sodales suscipit. Nunc finibus ac arcu
        sit amet molestie. Sed molestie ut mi eu mollis. Cras imperdiet mattis purus sit amet tempor.
    </p>
</div>
{% endblock %}

loanApp/userApp/templates/home.html
{% extends 'base.html' %}

{% block content %}
  <div style="height: 100vh">
    <div class="flex-center flex-column">
      <h5 class="animated fadeIn mb-3">Welcome. We're glad you're with us.</h5>
      {% if not user.is_authenticated %}
        <a href="{% url 'login' %}" class="btn  blue-gradient btn-rounded animated fadeIn">Sign In</a>
      {% endif %}
    </div>
  </div>
{% endblock %}

loanApp/userApp/templates/loan_application.html
{% load crispy_forms_tags %}
<div class="container">
    <div class="col-md col-sm">

            {{ form|crispy }}
    </div>
</div>

loanApp/userApp/templates/not_verified.html
{% extends 'base.html' %}

{% block content %}
<br/><br/><br/><br/>
<div class="container mt-5">
    <div class="modal-dialog modal-notify modal-danger" role="document">
        <!--Content-->
        <div class="modal-content">
            <!--Header-->
            <div class="modal-header">
                <p class="heading lead">User Not Verified</p>
            </div>

            <!--Body-->
            <div class="modal-body">
                <div class="text-center">
                    <i class="fas fa-times fa-4x mb-3 animated rotateIn"></i>
                    <p>Your account is not verified. Click <a href="{% url 'resend_sms' %}">here</a> to verify it.</p>
                </div>
            </div>

        </div>
        <!--/.Content-->
    </div>
</div>
{% endblock %}